package cn.com.ty.lift.enterprise.custom.service.impl;

import cn.com.ty.lift.enterprise.custom.dao.entity.PropertyCompany;
import cn.com.ty.lift.enterprise.custom.dao.entity.PropertyContact;
import cn.com.ty.lift.enterprise.custom.dao.mapper.PropertyCompanyMapper;
import cn.com.ty.lift.enterprise.custom.dao.mapper.PropertyContactMapper;
import cn.com.ty.lift.enterprise.custom.service.PropertyCompanyService;
import cn.com.xwy.boot.web.dto.RestResponse;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import lombok.AllArgsConstructor;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;

import java.util.List;
import java.util.Map;

/**
 * <p>
 * (甲方公司)客户表 服务实现类
 * </p>
 *
 * @author wang-hai-cheng
 * @since 2019-11-11
 */
@Transactional
@Service
@AllArgsConstructor
public class PropertyCompanyServiceImpl extends ServiceImpl<PropertyCompanyMapper, PropertyCompany> implements PropertyCompanyService {
    private final PropertyContactMapper contactMapper;

    public String savePropertyCompany(@RequestBody PropertyCompany propertyCompany) {
        if (null == this.getOne(new QueryWrapper<PropertyCompany>().eq("name", propertyCompany.getName()))) {
            if (this.save(propertyCompany)) {
                return "新增客户成功";
            } else {
                return "新增客户失败";
            }
        } else {
            return "客户已存在";
        }
    }

    public String delete(@PathVariable int id) {
        //维保电梯大于0
        if (this.getMaintenanceLiftNum() > 0) {
            //就不删除
            return "维保电梯大于0，无法删除";
        } else {
            //如果维保电梯小于等于0
            if (this.removeById(id)) {
                this.deleteForContact(id);
                return "删除成功";
            } else {
                return "删除失败";
            }
        }
    }

    public int deleteForContact(int id) {
        return contactMapper.delete(new QueryWrapper<PropertyContact>().eq("pp_company_id", id));
    }

    private int getMaintenanceLiftNum() {
        //查询维保电梯数
        //查询维保电梯数
        //查询维保电梯数
        //查询维保电梯数
        //查询维保电梯数
        //查询维保电梯数
        //查询维保电梯数
        //查询维保电梯数
        //查询维保电梯数
        //查询维保电梯数
        //查询维保电梯数
        //查询维保电梯数
        //查询维保电梯数
        return 888;
    }

    public RestResponse propertyCompanyListResponse(Long mtCompanyId,Integer pageNum, Integer pageSize) {
        Page<PropertyCompany> page = new Page<>(pageNum, pageSize);
        List<Map<String, Object>> records = this.pageMaps(page, new QueryWrapper<PropertyCompany>()
                .select("id", "code", "name", "address", "telephone")
                .eq("mt_company_id",mtCompanyId)).getRecords();
        records.forEach(record -> {
            record.put("maintenanceLiftNum", this.getMaintenanceLiftNum());
        });
        return RestResponse.ok(records, "查询成功");
    }


    public RestResponse propertyCompaniesFromRowName(Long mtCompanyId,Integer pageNum, Integer pageSize, String rowName, Object rowValue) {
        Page<PropertyCompany> page = new Page<>(pageNum, pageSize);
        List<Map<String, Object>> records = this.pageMaps(page, new QueryWrapper<PropertyCompany>()
                .select("id", "code", "name", "address", "telephone").like(rowName, rowValue)
                .eq("mt_company_id",mtCompanyId))
                .getRecords();
        records.forEach(record -> {
            record.put("maintenanceLiftNum", this.getMaintenanceLiftNum());
        });
        return RestResponse.ok(records, "查询成功");
    }
}